#!/usr/bin/perl

my $indent = 0;

my $error = "\e[31m";
my $make = "\e[32m";
my $normal = "\e[37m";
print ($error);
MAINLOOP:while (<>)
{
    if (/^make\[[[:digit:]]\]: /)
    {
	s/^make\[[[:digit:]]\]: //;
	$indent++ if (/^Entering directory/);
	print ($make, "  " x $indent, $_, $error);
	$indent-- if (/^Leaving directory/);
	next MAINLOOP;
    }
    if (/:/)
    {
	print ($error, "  " x $indent, $_, $error);
	next MAINLOOP;
    }
    if (/^gcc/)
    {
	s/(-I[^[:blank:]]*)/\e[34m$1\e[37m/g;
	s/(-L[^[:blank:]]*)/\e[35m$1\e[37m/g;
	print ($normal, "  " x $indent, $_, $error);
	next MAINLOOP;
    }
    print ($normal, "  " x $indent, $_, $error);
}
print ($normal);
